define(
    [
        'jquery',
        'underscore',
        'backbone',
        'models/services/data/ui/WorkflowAction',
        'collections/SplunkDsBase'
    ],
    function($, _, Backbone, WorkflowActionModel, SplunkDsBaseCollection) {
        return SplunkDsBaseCollection.extend({
            url: 'data/ui/workflow-actions',
            model: WorkflowActionModel,
            initialize: function(){
                SplunkDsBaseCollection.prototype.initialize.apply(this, arguments);
            },
            getEventActions: function(event) {
                var idxs = [];
                this.each(function(model, i) {
                    if(model.entry.content.get('display_location') != 'field_menu'){
                        idxs.push(i);
                    }
                },this);
                return idxs;
            },
            getFieldActions: function(field, event) {
                return this._filterByField(field, event);
            },
            _filterByField: function(field, event) {
                var idxs = [];
                this.each(function(model, i) {
                    var fields_str = model.entry.content.get('fields'),
                        fields = _(fields_str.split(',')).map(function(field) { return $.trim(field); },this),
                        eventtypes = _((model.entry.content.get('eventtypes') || '').split(',')).map(function(eventtype) {
                            return $.trim(eventtype);
                        },this),
                        eventtype = event.get('eventtype');

                    if(eventtype && _(eventtype).intersection(eventtypes).length > 0) {
                        if(model.entry.content.get('display_location') != "event_menu") {
                            if(fields.length == 1){
                                var f = fields[0];
                                if(f.indexOf('*')>-1){
                                     if(f === '*'){
                                        idxs.push(i);
                                     } else {
                                        var r;
                                        try { r = new RegExp(f); } catch(e) {}
                                        if(r) {
                                            var result = r.exec(field);
                                            if(result && result.length>0) {
                                                idxs.push(i);
                                            }
                                        }
                                     }
                                } else {
                                    if(f == field){
                                        idxs.push(i);
                                    }    
                                }
                            } else {
                                if(fields_str.indexOf('*') == -1){ 
                                    var allFieldsPresent = true;
                                    if(fields.indexOf(field) > -1) {
                                        _(fields).each(function(f) {
                                            if(!event.get(f)){
                                                allFieldsPresent = false;
                                            }
                                        },this);
                                        allFieldsPresent && idxs.push(i);
                                    }
                                }                        
                            }
                        }
                    }
                },this);
                return idxs;
            }
        });
    }
);
