define(
    [
        'backbone',
        'underscore',
        'models/SplunkDBase'
    ],
    function(Backbone, _, SplunkDBaseModel) {
        return SplunkDBaseModel.extend({
            url: "data/ui/workflow-actions",
            initialize: function() {
                SplunkDBaseModel.prototype.initialize.apply(this, arguments);
            },
            /**
             *  $field$ 
             */
            fieldSubstitute: function(text, data) {
                var settings = {
                        interpolate : /\$([\s\S]+?)\$/g 
                    },
                    $matches$ = text.match(settings.interpolate);

                //underscore templates will raise if the value to be replaced
                //is undefined.  Like 5.0, we will strip out $ delimited values
                //if they do not exist in event.  
                if($matches$) { 
                    _($matches$).each(function($string$) {
                        if(!data[$string$.match(/\$([\s\S]+?)\$/)[1]]){
                            text = text.replace($string$, '');
                        }
                    },this);
                }
                return _.template(text, data, settings);
            },
            /**
             * $@sid$ $@offset$, $@namespace$, $@latest_time$, $@field_name$, $@field_value$ 
             */
            systemSubstitute: function(text, sid, offset, namespace, latest_time, fieldName, fieldValue) {
                var settings = {
                        interpolate : /\$@([\s\S]+?)\$/g
                    },
                    data = {
                        sid: sid,
                        offset: offset,
                        namespace: namespace,
                        //FIXME: why was the old UI passing this as empty 
                        latest_time: '', //latest_time,
                        field_name: fieldName,
                        field_value: fieldValue
                    };
                return _.template(text, data, settings);
            }
        });
    }
);
