define(function(require, exports, module) {    
    var utils = require("util/splunkd_utils");
    var config = require("JS_CACHE/config");
    
    // This regex captures things of the form: "/{locale}/splunkd/__raw", e.g.
    // "/en-US/splunkd/__raw".
    var regexp = new RegExp("/[^\/]*/splunkd\/__raw", "g");
    var fullpath = utils.fullpath;
    
    // The original splunkd_utils.fullpath() method is hard coded to use
    // the Splunkweb "/{locale}/splunkd/__raw" endpoint. This is problematic
    // when we are not running in the context of Splunkweb. As such, we 
    // intercept the call, and replace any use of the above with the actual
    // PROXY_PATH, which we have as our configuration.
    utils.fullpath = function() {
        var resolvedPath = fullpath.apply(utils, arguments);
        return resolvedPath.replace(regexp, config.PROXY_PATH);
    };
    
    return utils; 
});