define([
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/shared/appbar/AppLabel.html'
],
function(
    _,
    module,
    BaseView,
    templateAppLabel
){
    return BaseView.extend({
        moduleId: module.id,
        className: 'app-bar-label-wrapper',
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.appNav.on('change', this.render, this);
            if (this.model.appNav.get('label') ||
                this.model.appNav.get('logo') ||
                this.model.appNav.get('icon'))
            {
                this.render();
            }
        },
        showLogo: function(){
            this.$el.find('.app-logo').show();
            this.$el.find('.app-name').hide();
        },
        showName: function(){
            this.$el.find('.app-name').show();
            this.$el.find('.app-logo').hide();
        },
        render: function() {
            var self = this;
            
            var html = _.template(templateAppLabel, {
                appLink: this.model.appNav.get('link'),
                appLabel: this.model.appNav.get('label'),
                appIcon: this.model.appNav.get('icon'),
                appLogo: this.model.appNav.get('logo')
            });
            this.$el.html(html);

            if (this.model.appNav.get('logo')) {
                var img = this.$el.find('.app-logo-img');
                if(parseInt(img.width, 10) > 2){
                    this.showLogo();
                }else{
                    this.showName();
                }

                img.load(function(){
                    if(parseInt(this.width, 10) > 2){
                        self.showLogo();
                    }
                });
            } else {
                this.showName();
            }

            return this;
        }
    });
});
